﻿using System;
using System.Windows.Forms;

namespace ELTE.Forms.ColorGrid
{
    /// <summary>
    /// Rácsgomb típusa.
    /// </summary>
    class GridButton : Button
    {
        /// <summary>
        /// Vízszintes rácskoordináta.
        /// </summary>
        public Int32 GridX { get; private set; }
        /// <summary>
        /// Függőleges rácskoordináta.
        /// </summary>
        public Int32 GridY { get; private set; }

        /// <summary>
        /// Rácsgomb példányosítása.
        /// </summary>
        /// <param name="x">Vízszintes rácskoordináta.</param>
        /// <param name="y">Függőleges rácskoordináta.</param>
        public GridButton(Int32 x, Int32 y) { GridX = x; GridY = y; }
    }
}
