﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ELTE.Forms.DynamicControls
{
    public partial class MainForm : Form
    {
        private Random _Random; // véletlenszám generátor
        private List<List<Button>> _Buttons; // gombok listának listája -> mátrixa    

        public MainForm()
        {
            InitializeComponent();

            _Random = new Random();
        }

        private void ButtonSize_Click(object sender, EventArgs e)
        {
            if (_Buttons != null) 
            // ha már vannak gombok az ablakban, töröljük azokat
            {
                foreach(var buttonList in _Buttons)
                    foreach (var button in buttonList)
                        Controls.Remove(button);
                   // a törlés pontosabban azt jelenti, hogy levesszük őket az ablakról
            }

            _Buttons = new List<List<Button>>();             
            // új mátrix létrehozása

            for (Int32 i = 0; i < _NumericV.Value; i++)       
                // addig megyünk, amíg a számlálók mondják
            {
                _Buttons.Add(new List<Button>());
                // hozzáadunk egy új sort a mátrixhoz
                for (Int32 j = 0; j < _NumericH.Value; j++)
                {
                    _Buttons[i].Add(new Button());
                    // hozzáaduk egy új gombot a mátrixhoz

                    _Buttons[i][j].Location = new Point(6 + j * 20, 50 + i * 20);
                    // beállítjuk a kezdőpontot
                    _Buttons[i][j].Name = "button" + i.ToString() + j.ToString();
                    // beállítjuk a nevét
                    _Buttons[i][j].Size = new Size(20, 20);
                    // beállítjuk a méretét
                    _Buttons[i][j].Text = String.Empty;       // beállítjuk a szövegét 
                    _Buttons[i][j].BackColor = Color.White;  // beállítjuk a kezdőszínét
                    
                    Controls.Add(_Buttons[i][j]);            // hozzáadjuk az ablak vezérlőihez
                    
                    _Buttons[i][j].Click += new EventHandler(Button_Click);  
                    // társítjuk hozzá a közös eseménykezelőt
                }
            }
            // átméretezzük az ablakot
            if (20 + 20 * _NumericH.Value > 400) 
                Width = Convert.ToInt32(20 + 20 * _NumericH.Value);
            else 
                Width = 400;
            Height = Convert.ToInt32(90 + 20 * _NumericV.Value);

        }

        // gomb eseménykezelője
        private void Button_Click(Object sender, EventArgs e)   
        {   
            // a sender a gombot adja meg, de a paraméter általános objektumtípus, ezért konvertálnunk kell           
            (sender as Button).BackColor = Color.FromArgb(_Random.Next(256), _Random.Next(256), _Random.Next(256));
            // véletlenszámgenerátor a színnek az aktuális időpillanattal elindítva
        }
    }
}
