﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Fibonacci
{
    delegate void NewResultEventHandler(Int32 n, BigInteger result);

    class FibonacciCalculator
    {
        public event NewResultEventHandler NewResult;

        public void Run(Int32 n)
        {
            Task task = new Task(() => Calculate(n));
            task.Start();
        }

        private void Calculate(Int32 n)
        {
            BigInteger first = 0, second = 1, third = 1;

            if(n >= 0)
            OnNewResult(0, second);

            if (n >= 1)
            OnNewResult(1, third);

            for (Int32 i = 2; i <= n; ++i)
            {
                first = second;
                second = third;
                third = second + first;
                OnNewResult(i, third);
                Thread.Sleep(100); // Szándékos lassítás
            }
        }

        private void OnNewResult(Int32 n, BigInteger result)
        {
            if (NewResult != null)
                NewResult(n, result);
        }
    }
}
