﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Windows.Forms;

namespace Fibonacci
{
    public partial class MainForm : Form
    {
        private delegate void ConsoleWriterDelegate();

        public MainForm()
        {
            InitializeComponent();
        }

        private void DoIt(object sender, EventArgs e)
        {
            _LbxResults.Items.Clear();

            FibonacciCalculator calc = new FibonacciCalculator();
            calc.NewResult += GotNewResult;
            calc.Run(Convert.ToInt32(_NupN.Value));
        }

        private void GotNewResult(Int32 n, BigInteger result)
        {
            if (_LbxResults.InvokeRequired)
            {
                Invoke(new NewResultEventHandler(GotNewResult), n, result);
                return;
            }
            _LbxResults.Items.Insert(0, n + ": " + result);
        }
    }
}
